
#if !defined(AFX_9500APP_H__B98F829F_2028_4C85_8741_3F87A563F442__INCLUDED_)
#define AFX_9500APP_H__B98F829F_2028_4C85_8741_3F87A563F442__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include "resource.h"

/* Basic type definitions */
typedef unsigned char   BYTE, *PBYTE;
typedef unsigned short  WORD, *PWORD;
typedef unsigned long   DWORD, *PDWORD;
typedef unsigned __int64 DWORD64, *PDWORD64;

#define OID_NDIS_SMSC_LAN_READ_REGS     			0xFF950001U
#define OID_NDIS_SMSC_PHY_READ_REGS     			0xFF950002U
#define OID_NDIS_SMSC_LAN_WRITE_REGS     			0xFF950003U
#define OID_NDIS_SMSC_PHY_WRITE_REGS     			0xFF950004U
#define OID_NDIS_SMSC_DUMP_LAN_REGS     			0xFF950005U
#define OID_NDIS_SMSC_DUMP_MAC_REGS					0xFF950006U
#define OID_NDIS_SMSC_DUMP_PHY_REGS     			0xFF950007U
#define OID_NDIS_SMSC_DUMP_TX_STATS     			0xFF950008U
#define OID_NDIS_SMSC_DUMP_RX_STATS     			0xFF950009U
#define OID_NDIS_SMSC_SAVE_E2P_TO_FILE     			0xFF95000AU
#define OID_NDIS_SMSC_ERASE_E2P     				0xFF95000BU
#define OID_NDIS_SMSC_WRITE_FILE_TO_E2P     		0xFF95000CU
#define OID_NDIS_SMSC_SEND_E2P_COMMAND				0xFF95000DU
#define OID_NDIS_SMSC_READ_E2P    					0xFF95000EU
#define OID_NDIS_SMSC_WRITE_E2P    	 				0xFF95000FU
#define OID_NDIS_SMSC_READ_E2P_BLOCK    			0xFF950010U
#define OID_NDIS_SMSC_WRITE_E2P_BLOCK     			0xFF950011U
#define OID_NDIS_SMSC_GET_E2P_SIZE  				0xFF950012U
#define OID_NDIS_SMSC_GET_DRIVER_INFO   			0xFF950013U
#define OID_NDIS_SMSC_ENABLE_DEBUG					0xFF950014U
#define OID_NDIS_SMSC_ENABLE_RESUME					0xFF950015U
#define OID_NDIS_SMSC_PHY_READ_REG_ADDRESS     		0xFF950016U
#define OID_NDIS_SMSC_PHY_WRITE_REG_ADDRESS			0xFF950017U

// E2pCmdType:
#define	E2P_CMD_EWDS			0x10000000UL // Erase/Write Disable
#define	E2P_CMD_EWEN			0x20000000UL // Erase/Write Enable
#define	E2P_CMD_ERAL			0x60000000UL // Erase All

#define MAX_EEPROM_SIZE		512

#define DEFAULT_FULLSPPED_POLL	1
#define DEFAULT_HIGHSPPED_POLL	1
#define MAX_HIGHSPPED_POLL	16
#define MAX_FULLSPPED_POLL	255
#define MIN_SELF_POWER	0
#define MAX_SELF_POWER	100
#define MAX_BUS_POWER	500
#define MIN_BUS_POWER	2
#define MAX_INCREMENT	255
#define MAX_INC_DIGIT	3
#define MAX_SERIAL_LEN	16


#define ID_REV_CHIP_ID1_				(0x9500UL)		// lan9500
#define	USB_VENDOR_ID_SMSC				((WORD)0x0424U)
#define	USB_PRODUCT_ID_SMSC_THERA		((WORD)0x9500U)


//error codes 
#define SUCCESS					0
#define ERROR_FAIL				1
#define ERROR_NOTSUPPORTED		2
#define ERROR_NODEVICE			3
#define ERROR_NOMEM				4
#define ERROR_PARAMETER			5
#define ERROR_NOHOSTCONTROLLER	6
#define ERROR_LINKDOWN			7
#define ERROR_EEPROMACCESS		8
#define ERROR_INVALIDEEPROMSIZE	9
#define ERROR_NOTSAME			10
#define SUCCESS_DONE            11


#define MAX_CHAR      200

typedef enum{   
	CMD_NULL,
	CMD_WRITE,
	CMD_READ,
	CMD_VERIFY,
    CMD_READ_REG,
    CMD_WRITE_REG,
    CMD_READ_PHY,     //Read phy register of specified phy
    CMD_WRITE_PHY,    //Write phy register of specified phy
	CMD_READ_PHY_SMI, //To read DWORD register on SMI (like switch register)
    CMD_WRITE_PHY_SMI, //To write DWORD register on SMI (like switch register)
}_ACTION;


DWORD gScannedChipid = 0; //scanned chip id, used to decide the eeprom format
char CurrentFolder[MAX_CHAR]="\0";

typedef struct _DEV_DESC
{
	BYTE bLength;            // DFLT=12h, Loaded from E2P=Yes, E2P Content=Don't care
	BYTE bDescriptorType;    // DFLT=01h, Loaded from E2P=Yes, E2P Content=Don't care
	WORD bcdUSB;             // DFLT=0200h, Loaded from E2P=Yes, E2P Content=Must be 0200h
	BYTE bDeviceClass;       // DFLT=FFh, Loaded from E2P=Yes, E2P Content=FFh
	BYTE bDeviceSubClass;    // DFLT=00h, Loaded from E2P=Yes, E2P Content=00
	BYTE bDeviceProtocol;    // DFLT=01h, Loaded from E2P=Yes, E2P Content=01
	BYTE bMaxPacketSize;     // DFLT=40h, Loaded from E2P=Yes, E2P Content=Must be 40h
	WORD IdVendor;           // DFLT=0424h, Loaded from E2P=Yes, E2P Content=programmable using GUI
	WORD IdProduct;          // DFLT=9500h, Loaded from E2P=Yes, E2P Content=programmable using GUI
	WORD bcdDevice;          // DFLT=0100h, Loaded from E2P=Yes, E2P Content=0100
	BYTE iManufacturer;      // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 1 if Manufacturer str. is enable in GUI
	BYTE iProduct;           // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 2 if Manufacturer str. is enable in GUI
	BYTE iSerialNumber;      // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 3
	BYTE bNumConfigurations; // DFLT=01h, Loaded from E2P=Yes, E2P Content=Must be 01h
}DEV_DESC, *PDEV_DESC;

typedef struct _CFG_DESC
{
	BYTE bLength;            // DFLT=09h, Loaded from E2P=Yes, E2P Content=Must be 09h
	BYTE bDescriptorType;    // DFLT=02h, Loaded from E2P=Yes, E2P Content=Don't care
	WORD wTotalLength;       // DFLT=0027h, Loaded from E2P=Yes, E2P Content=Must be 0027h
	BYTE bNumInterfaces;     // DFLT=01h, Loaded from E2P=Yes, E2P Content=Must be 01h
	BYTE bConfigurationValue;// DFLT=01h, Loaded from E2P=Yes, E2P Content=Must be 01h
	BYTE iConfiguration;     // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 4 if Manufacturer str. is enable in GUI
	BYTE bmAttributes;       // DFLT=A0h, Loaded from E2P=Yes, E2P Content=programmable using GUI
	BYTE bMaxPower;          // DFLT=01h(Self power)/FAh(Bus Power), Loaded from E2P=Yes, E2P Content=programmable using GUI
}CFG_DESC, *PCFG_DESC;

typedef struct _IF_DESC
{
	BYTE bLength;            // DFLT=09h, Loaded from E2P=Yes, E2P Content=Must be 09h
	BYTE bDescriptorType;    // DFLT=04h, Loaded from E2P=Yes, E2P Content=Must be 04h
	BYTE bIntefaceNumber;    // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 00h
	BYTE bAlternateSetting;  // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 00h
	BYTE bNumEndpoints;      // DFLT=03h, Loaded from E2P=Yes, E2P Content=Must be 03h
	BYTE bIntefaceClass;     // DFLT=FFh, Loaded from E2P=Yes, E2P Content=FFh
	BYTE bIntefaceSubClass;  // DFLT=00h, Loaded from E2P=Yes, E2P Content=00h
	BYTE bIntefaceProtocol;  // DFLT=FFh, Loaded from E2P=Yes, E2P Content=FFh
	BYTE iInterface;      // DFLT=00h, Loaded from E2P=Yes, E2P Content=Must be 5 if Manufacturer str. is enable in GUI
}IF_DESC, *PIF_DESC;



struct format9500
{
	BYTE Signature;
	BYTE MacAddr[6];
	BYTE FsPollInterval;
	BYTE HsPollInterval;
	BYTE ConfigFlag;
	BYTE LangIdLow;
	BYTE LangIdHigh;
	BYTE ManufacturerStrLen;
	BYTE ManufacturerStrOffset;
	BYTE ProductStrLen;
	BYTE ProductStrOffset;
	BYTE SerialNumberStrLen;
	BYTE SerialNumberStrOffset;
	BYTE ConfigStrLen;
	BYTE ConfigStrOffset;
	BYTE InterfaceStrLen;
	BYTE InterfaceStrOffset;
	BYTE HsDeviceDescLen;
	BYTE HsDeviceDescOffset;
	BYTE HsCfgIfDescLen;
	BYTE HsCfgIfDescOffset;
	BYTE FsDeviceDescLen;
	BYTE FsDeviceDescOffset;
	BYTE FsCfgIfDescLen;
	BYTE FsCfgIfDescOffset;
	BYTE Reserved[2];
	DEV_DESC DevDesc;
	CFG_DESC CfgDesc;
	IF_DESC  IfDesc;
	WORD UnicodeStr[222];
};

struct format9500A
{
	BYTE Signature;
	BYTE MacAddr[6];
	BYTE FsPollInterval;
	BYTE HsPollInterval;
	BYTE ConfigFlag;
	BYTE LangIdLow;
	BYTE LangIdHigh;
	BYTE ManufacturerStrLen;
	BYTE ManufacturerStrOffset;
	BYTE ProductStrLen;
	BYTE ProductStrOffset;
	BYTE SerialNumberStrLen;
	BYTE SerialNumberStrOffset;
	BYTE ConfigStrLen;
	BYTE ConfigStrOffset;
	BYTE InterfaceStrLen;
	BYTE InterfaceStrOffset;
	BYTE HsDeviceDescLen;
	BYTE HsDeviceDescOffset;
	BYTE HsCfgIfDescLen;
	BYTE HsCfgIfDescOffset;
	BYTE FsDeviceDescLen;
	BYTE FsDeviceDescOffset;
	BYTE FsCfgIfDescLen;
	BYTE FsCfgIfDescOffset;
	BYTE LSBGPIOWake;
	BYTE MSBGPIOWake;
	BYTE GPIOPMEFlags;
	BYTE Reserved;
	DEV_DESC DevDesc;
	CFG_DESC CfgDesc;
	IF_DESC  IfDesc;
	WORD UnicodeStr[222];
};

struct format9530
{
	BYTE Signature;
	BYTE MacAddr[6];
	BYTE FsPollInterval;
	BYTE HsPollInterval;
	BYTE ConfigFlag;
	BYTE LangIdLow;
	BYTE LangIdHigh;
	BYTE ManufacturerStrLen;
	BYTE ManufacturerStrOffset;
	BYTE ProductStrLen;
	BYTE ProductStrOffset;
	BYTE SerialNumberStrLen;
	BYTE SerialNumberStrOffset;
	BYTE ConfigStrLen;
	BYTE ConfigStrOffset;
	BYTE InterfaceStrLen;
	BYTE InterfaceStrOffset;
	BYTE HsDeviceDescLen;
	BYTE HsDeviceDescOffset;
	BYTE HsCfgIfDescLen;
	BYTE HsCfgIfDescOffset;
	BYTE FsDeviceDescLen;
	BYTE FsDeviceDescOffset;
	BYTE FsCfgIfDescLen;
	BYTE FsCfgIfDescOffset;
	BYTE LSBGPIOWake;
	BYTE MSBGPIOWake;
	BYTE GPIOPMEFlags;
	BYTE Reserved;
	DEV_DESC DevDesc;
	CFG_DESC CfgDesc;
	IF_DESC  IfDesc;
	WORD UnicodeStr[222];
};

struct format9730
{
	BYTE Signature;
	BYTE MacAddr[6];
	BYTE FsPollInterval;
	BYTE HsPollInterval;
	BYTE ConfigFlag;
	BYTE LangIdLow;
	BYTE LangIdHigh;
	BYTE ManufacturerStrLen;
	BYTE ManufacturerStrOffset;
	BYTE ProductStrLen;
	BYTE ProductStrOffset;
	BYTE SerialNumberStrLen;
	BYTE SerialNumberStrOffset;
	BYTE ConfigStrLen;
	BYTE ConfigStrOffset;
	BYTE InterfaceStrLen;
	BYTE InterfaceStrOffset;
	BYTE HsDeviceDescLen;
	BYTE HsDeviceDescOffset;
	BYTE HsCfgIfDescLen;
	BYTE HsCfgIfDescOffset;
	BYTE FsDeviceDescLen;
	BYTE FsDeviceDescOffset;
	BYTE FsCfgIfDescLen;
	BYTE FsCfgIfDescOffset;
	BYTE LSBGPIOWake;
	BYTE MSBGPIOWake;
	BYTE GPIOPMEFlags;
	BYTE Reserved;
	DEV_DESC DevDesc;
	CFG_DESC CfgDesc;
	IF_DESC  IfDesc;
	WORD UnicodeStr[222];
};



struct format9514 //eeprom format for 9512/14 
{
	BYTE Signature;
	BYTE MacAddr[6];
	BYTE FsPollInterval;
	BYTE HsPollInterval;
	BYTE ConfigFlag;
	BYTE LangIdLow;
	BYTE LangIdHigh;
	BYTE ManufacturerStrLen;
	BYTE ManufacturerStrOffset;
	BYTE ProductStrLen;
	BYTE ProductStrOffset;
	BYTE SerialNumberStrLen;
	BYTE SerialNumberStrOffset;
	BYTE ConfigStrLen;
	BYTE ConfigStrOffset;
	BYTE InterfaceStrLen;
	BYTE InterfaceStrOffset;
	BYTE HsDeviceDescLen;
	BYTE HsDeviceDescOffset;
	BYTE HsCfgIfDescLen;
	BYTE HsCfgIfDescOffset;
	BYTE FsDeviceDescLen;
	BYTE FsDeviceDescOffset;
	BYTE FsCfgIfDescLen;
	BYTE FsCfgIfDescOffset;
	BYTE Reserved[2];
	WORD HubVendorID;	//hub registers start
	WORD HubProductID;
	WORD HubDeviceID;
	BYTE ConfigDataByte1;
	BYTE ConfigDataByte2;
	BYTE ConfigDataByte3;
	BYTE NonRemovableDevices;
	BYTE PortDisableSelf;
	BYTE PortDisableBus;
	BYTE MaxPowerSelf;
	BYTE MaxPowerBus;
	BYTE MaxCurrentSelf;
	BYTE MaxCurrentBus;
	BYTE PowerOnTime;
	BYTE BoostUp;
	BYTE Boost75;
	BYTE Boost40;
	BYTE DebugMonitor;
	BYTE PortSwap;
	BYTE PortRemap12;
	BYTE PortRemap34;
	BYTE PortRemap5;
	BYTE StausCommand;	//hub registers end
	DEV_DESC DevDesc;
	CFG_DESC CfgDesc;
	IF_DESC  IfDesc;
	WORD UnicodeStr[222];
};


typedef union _E2P_STRUCT
{
	
	BYTE E2pBuf[MAX_EEPROM_SIZE];
	WORD WBuf[256];
	struct format9500 format;
	struct format9500A format9500A;
	struct format9514 format9514;
    struct format9530 format9530;
	struct format9730 format9730;
}E2P_STRUCT, *PE2P_STRUCT;


typedef struct _DRIVER_VERSION {
	DWORD	Major;
	DWORD	Minor;
	DWORD	Build;
	DWORD	Qfe;
}DRIVER_VERSION, *PDRIVER_VERSION;


typedef struct
{
	unsigned char curMacAddr[6];
	unsigned char maxMacAddr[6];
	int macIncrement;
	char *curSerialNum;
	char *maxSerialNum; //if NULL, means all "F"
	int serialIncrement;
	DWORD phyAddress;
	DWORD registerAddress;
	bool dataValueValid;
	DWORD dataValue;

	int macPos;		//Mac address's physical location in the ini file
	int preMacLen;
	int preSerialLen;	//Serial number size in the ini file
	int serialPos;		//Serial number's physical location in the ini file

	int FullSpeedPollingInterval;
	int HighSpeedPollingInterval;
	char *ManufactureString;
	char *ProductString;
	char *ConfigurationString;
	char *InterfaceString;
	int RemoteWakeupEnable;
	int BusPower;
	int MaxPower;
	WORD VendorID;
	WORD ProductID;
	WORD bcd;
	int hc;
	int hc_valid;
	int hc_port;
	int hc_port_valid;
	int hub_port;
	int hub_port_valid;

	char *eepromFileName; //eeprom binary file name
	char *iniFilename; //INI file name

	_ACTION action;
	int eeprom_size;
	int real_size;
	int curMacValid; //curMacAddr is valid

	
	int reloadEEPROM;
	int endMessage;

	char	SrcIpAddr[4];  //my ip addr
	char	DestIpAddr[4]; // dest ip addr

	char loop;  //flag to do loop test
	char saveNext;	//Save next mac and serial in the file no matter it loop or not
	int GPIOPin;
	int GPIOPinValid;
	int GPIOState;
	int GPIOTime;
	int GPIOType;
	int PHYBoost;	// for 9500A start
	int LEDSelect;
	int GPIOWake0;
	int GPIOWake1;
	int GPIOWake2;
	int GPIOWake3;
	int GPIOWake4;
	int GPIOWake5;
	int GPIOWake6;
	int GPIOWake7;
	int GPIOWake8;
	int GPIOWake9;
	int GPIOWake10;
	int GPIOPMEEnable;
	int GPIOPMEConfiguration;
	int GPIOPMELength;
	int GPIOPMEPolarity;
	int GPIOBufferType;
	int GPIOPMEWOLSelect;
	int GPIO10DetectionSelect; // 9500A parameter end
	/* for 9512/9514 */
	WORD HubVendorID;	//hub parameters start
	WORD HubProductID;
	WORD HubDeviceID;
	int HubSelfPower;
	int HighSpeedDisable;
	int MultipleTTEnable;
	int EOPDisable;
	int OverCurrentSense;
	int PortPowerSwitching;
	int OverCurrentTimerDelay;
	int CompoundDevice;
	int Port1NonRemovable;
	int Port2NonRemovable;
	int Port3NonRemovable;
	int Port4NonRemovable;
	int Port5NonRemovable;
	int Port1DisableSelf;
	int Port2DisableSelf;
	int Port3DisableSelf;
	int Port4DisableSelf;
	int Port5DisableSelf;
	int Port1DisableBus;
	int Port2DisableBus;
	int Port3DisableBus;
	int Port4DisableBus;
	int Port5DisableBus;
	int MaxPowerSelfPowered;
	int MaxPowerBusPowered;
	int MaxCurrentSelfPowered;
	int MaxCurrentBusPowered;
	int PowerOnTime;
	int BoostPort0;
	int BoostPort2;
	int BoostPort3;
	int BoostPort4;
	int BoostPort5;
	int USBDP0USBDM0Swapped;
	int USBDP2USBDM2Swapped;
	int USBDP3USBDM3Swapped;
	int USBDP4USBDM4Swapped;
	int USBDP5USBDM5Swapped;
	int PortRemappingEnable;
	int PhysicalPort1Mapped;
	int PhysicalPort2Mapped;
	int PhysicalPort3Mapped;
	int PhysicalPort4Mapped;
	int PhysicalPort5Mapped;
	int Reset;
	int UsbAttachWriteProtect; //hub parameters end
}EEPROM_CONTENT, *PEEPROM_CONTENT;


struct SECTION{
	char title[50];
	int (*parser)(FILE* handle, PEEPROM_CONTENT content);
};

enum{
	FIELD_CUR_MAC,		//9500/9500A/9512/9514/9530/9730/89530 common parameters
	FIELD_MAC_INC,
	FIELD_MAX_MAC,
	FIELD_CUR_SERIAL,
	FIELD_SERIAL_INC,
	FIELD_MAX_SERIAL,
	FIELD_MANUF_STR,
	FIELD_MANUF_EN,
	FIELD_PRODU_STR,
	FIELD_PRODU_EN,
	FIELD_CONF_EN,
	FIELD_CONF_STR,
	FIELD_INTERFACE_EN,
	FIELD_INTERFACE_STR,
	FIELD_VENDORID,
	FIELD_PRODUCTID,
	FIELD_BCD,
	FIELD_HIGHSPEED,
	FIELD_FULLSPEED,
	FIELD_BUSPOWER,
	FIELD_REMOTEWAKE,
	FIELD_MAXPOWER,		//9500/9500A/9512/9514/9530/9730/89530 common parameters end
	FIELD_PHYBOOST,		// 9500A/9530/9730/89530 parameters
	FILED_LED_SELECT,
	FILED_GPIO_WAKE0,
	FILED_GPIO_WAKE1,
	FILED_GPIO_WAKE2,
	FILED_GPIO_WAKE3,
	FILED_GPIO_WAKE4,
	FILED_GPIO_WAKE5,
	FILED_GPIO_WAKE6,
	FILED_GPIO_WAKE7,
	FILED_GPIO_WAKE8,
	FILED_GPIO_WAKE9,
	FILED_GPIO_WAKE10,
	FILED_GPIO_PME_ENABLE,
	FILED_GPIO_PME_CONFIG,
	FILED_GPIO_PME_LENGTH,
	FILED_GPIO_PME_POLARITY,
	FILED_GPIO_PME_BUFFERTYPE,
	FILED_GPIO_PME_WOLSELECT,
	FILED_GPIO_PME_10DETECTION_SELECT, //9500A parameters end
	FIELD_HUB_VENDOR_ID, //hub parameters
	FIELD_HUB_PRODUCT_ID,
	FIELD_HUB_DEVICE_ID,
	FIELD_HUB_SELF_POWER,
	FIELD_HIGHSPEED_DISABLE,
	FIELD_MULTIPLE_TT_ENABLE,
	FIELD_EOP_DISABLE,
	FIELD_OVERCURRENT_SENSE,
	FIELD_PORT_POWER_SWITCHING,
	FIELD_OVER_CURRENT_TIME_DELAY,
	FIELD_COMPOUND_DEVICE,
	FIELD_PORT1_NON_REMOVABLE,
	FIELD_PORT2_NON_REMOVABLE,
	FIELD_PORT3_NON_REMOVABLE,
	FIELD_PORT4_NON_REMOVABLE,
	FIELD_PORT5_NON_REMOVABLE,
	FIELD_SELF_PORT1_DISABLE,
	FIELD_SELF_PORT2_DISABLE,
	FIELD_SELF_PORT3_DISABLE,
	FIELD_SELF_PORT4_DISABLE,
	FIELD_SELF_PORT5_DISABLE,
	FIELD_BUS_PORT1_DISABLE,
	FIELD_BUS_PORT2_DISABLE,
	FIELD_BUS_PORT3_DISABLE,
	FIELD_BUS_PORT4_DISABLE,
	FIELD_BUS_PORT5_DISABLE,
	FIELD_MAX_POWER_SELF,
	FIELD_MAX_POWER_BUS,
	FIELD_MAX_CURRENT_SELF,
	FIELD_MAX_CURRENT_BUS,
	FIELD_POWER_ON_TIME,
	FIELD_BOOST_PORT0,
	FIELD_BOOST_PORT2,
	FIELD_BOOST_PORT3,
	FIELD_BOOST_PORT4,
	FIELD_BOOST_PORT5,
	FIELD_USBDP0USBDM0_SWAPPED,
	FIELD_USBDP2USBDM2_SWAPPED,
	FIELD_USBDP3USBDM3_SWAPPED,
	FIELD_USBDP4USBDM4_SWAPPED,
	FIELD_USBDP5USBDM5_SWAPPED,
	FIELD_PORT_REMAP_ENABLE,
	FIELD_PHYSICAL_PORT1_MAPPED,
	FIELD_PHYSICAL_PORT2_MAPPED,
	FIELD_PHYSICAL_PORT3_MAPPED,
	FIELD_PHYSICAL_PORT4_MAPPED,
	FIELD_PHYSICAL_PORT5_MAPPED,
	FILELD_RESET,
	FILELD_USB_ATTACH_WRITE_PROTECT,
	SECTION_MAC_ADDRESS,	//section fields
	SECTION_SERIAL_NUMBER,
	SECTION_STRING,
	SECTION_ID,
	SECTION_POLLING_INTERVAL,
	SECTION_POWER,
	SECTION_HUB_ID,
	SECTION_HUB_CONFIG_DATABYTE,
	SECTION_NON_REMOVABLE_DEVICES,
	SECTION_PORT_DISABLE_SELF,
	SECTION_PORT_DISABLE_BUS,
	SECTION_HUB_POWER,
	SECTION_BOOSTUP,
	SECTION_PORT_SWAP,
	SECTION_PORT_REMAP,
	SECTION_STATUS_COMMAND,
	SECTION_CONFIG_FLAGS,
	SECTION_GPIOWAKE,
	SECTION_GPIOPME,

	FIELD_CNT
};


enum{
	FIELDRESULT_EMPTY, // not value saved
	FIELDRESULT_OK,		//valid format value
	FIELDRESULT_INVALID //invalid format value
};

static int field[FIELD_CNT];


#define PRINT_MSG(msg, ...)	\
	printf(msg, ##__VA_ARGS__);

#define PRINT_WARNING(msg, ...)				\
	{					\
		printf("WARNING: ");\
		printf(msg, ##__VA_ARGS__);\
	}
#define PRINT_ERROR(msg, ...)				\
	{					\
		printf("ERROR: ");\
		printf(msg, ##__VA_ARGS__);\
	}


#endif // !defined(AFX_9500APP_H__B98F829F_2028_4C85_8741_3F87A563F442__INCLUDED_)
